// stablo.h - Deklaracije paketa za obradu sa binarnih stabala.

typedef struct cvor { int broj; struct cvor *levo, *desno; } Cvor;
typedef Cvor *Stablo;

Stablo stvori  (void);                  // Stvaranje praznog stabla.
int    vel     (Stablo stb);            // Broj čvorova u stablu.
int    zbir    (Stablo stb);            // Zbir brojeva u stablu.
void   pisi_kld(Stablo stb);            // Prefiksno ispisivanje.
void   pisi_lkd(Stablo stb);            // Infiksno ispisivanje.
void   pisi_ldk(Stablo stb);            // Postfiksno ispisivanje.
void   crtaj   (Stablo stb, int nivo);  // Grafički prikaz stabla.
int    pojav   (Stablo stb, int b);     // Broj pojavljivanja u stablu.
int    min_u   (Stablo stb);            // Najmanji u uređenom stablu.
int    max_u   (Stablo stb);            // Najveći u uređenom stablu.
int    min_n   (Stablo stb);            // Najmanji u neuređenom stablu.
int    max_n   (Stablo stb);            // Najveći u neuređenom stablu.
_Bool  uredjeno(Stablo stb);            // Da li je stablo uređeno?
Cvor  *nadji_u (Stablo stb, int b);     // Traženje u uređenom stablu.
Cvor  *nadji_n (Stablo stb, int b);     // Traženje u neuređenom stablu.
Stablo dodaj_u (Stablo stb, int b);     // Dodavanje u uređeno stablo.
Stablo dodaj_n (Stablo stb, int b);     // Dodavanje u neuređeno stablo.
Stablo citaj_u (int n);                 // Čitanje uređenog stabla.
Stablo citaj_n (int n);                 // Čitanje neuređenog stabla.
Stablo brisi   (Stablo stb);            // Brisanje celog stabla.
Stablo izost_u (Stablo stb, int b);     // Izost. iz uređenog stabla.
Stablo izost_n (Stablo stb, int b);     // Izost. iz neuređenog stabla.
Stablo balans_u(Stablo stb);            // Balansiranje uređenog stabla.
Stablo balans_n(Stablo stb);            // Balansiranje neuređenog stabla.
